
/**********************************************************************************
FUNCTION:	CRC definitions
AUTHOR:		Emil Lenchak
DATE:		March, 2004
COPYRIGHT:	Texas Instruments, 2004
TOOLS:		Built with IAR Kickstart V2/MS Visual C++ 6.0
***********************************************************************************/

#ifndef _MSP430_CRC
#define _MSP430_CRC

/************************
	CONSTANTS
************************/

#ifdef __ICC430__
#define TBL_MEM const
#else
#define TBL_MEM
#endif 

#define CRC_MSG_MAXSIZE	    20
#define CRC_TABLE_SIZE	    256

#define CRC_TEST_SEQ        "123456789"

#define CRC16_CHECK         0xFEE8
#define CRC16R_CHECK	    0xBB3D
#define CRC32_CHECK			0xFC891918
#define CRC32R_CHECK	    0xCBF43926

// CRC-16: x16 + x15 + x2 + 1
#define CRC16_POLY			0x8005
#define CRC16_INIT_REM      0x0
#define CRC16_FINAL_XOR     0x0

#define CRC16R_POLY         0xA001
#define CRC16R_INIT_REM     0x0
#define CRC16R_FINAL_XOR    0x0

// CRC-CCITT: x16 + x12 + x5 + 1
//#define CRC16_POLY	    0x1021
//#define CRC16_POLY_REF
//#define CRC16_INIT_REM    0x0
//#define CRC16_FINAL_XOR   0x0

// CRC-32: x32 + ... + 1
#define CRC32_POLY	    0x04C11DB7
#define CRC32_INIT_REM      0xFFFFFFFF
#define CRC32_FINAL_XOR     0xFFFFFFFF

#define CRC32R_POLY	    0xEDB88320
#define CRC32R_INIT_REM     0xFFFFFFFF
#define CRC32R_FINAL_XOR    0xFFFFFFFF

#endif  // _MSP430_CRC
